#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */

#include "peri.h"
#include "usbdrv.h"

#define RQ_SET_LED         0
#define RQ_SET_LED_VALUE   1
#define RQ_GET_SWITCH      2
#define RQ_GET_LIGHT       3
#define ENERGY 0
#define SECURITY 1
uint8_t y=0;
uint8_t state = ENERGY;// read state,not write yet

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{	static int y;
    usbRequest_t *rq = (void *)data;

    /* declared as static so they stay valid when usbFunctionSetup returns */
    static uint8_t switch_state;
    static uint16_t light;
     uint8_t pir = (PIND >> 5) & 0x1;
     uint16_t result = read_adc(PC4);

    if (rq->bRequest == RQ_GET_SWITCH)
    {
        switch_state = IS_SWITCH_PRESSED();

        /* point usbMsgPtr to the data to be returned to host */
        usbMsgPtr = &switch_state;

        /* return the number of bytes of data to be returned to host */
        return 1;
    }
  /*  else if (rq->bRequest == RQ_SET_LED_VALUE)
    {
            uint8_t led_val = rq->wValue.bytes[0];
            set_led_value(led_val);
	    return 0;

    }*/
    else if (rq->bRequest == RQ_GET_LIGHT)
    {

        light = read_adc(4);
        usbMsgPtr = &light;
	return sizeof(light);


    }
    /* default for not implemented requests: return no data back to host */
	else if (rq->bRequest == ENERGY){
    state=0;
  }
  else if (rq->bRequest == SECURITY){
    state=1;
  }
	return sizeof(pir);

}

/* ------------------------------------------------------------------------- */
int main(void)
{
    init_peripheral();

    usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();

    /* enable global interrupts */
    sei();

    /* main event loop */
    for(;;)
    {
        usbPoll();
	uint8_t pir = (PIND >> 5) & 0x1;
	uint16_t result = read_adc(PC4);
	if(state==0){
            if(pir){
                if(result >=0 && result <=500){
                    set_led_value(7);
                }
                else if(result >500 && result <=1023){
                    set_led_value(0);
                }
            }
            else
                set_led_value(0);
    	}
	else {
            if(pir){
                    set_led_value(y);
                    _delay_ms(100);
                    y=y+1;
                    if(y==8) y=0;
            }
	}
    }

    return 0;
}

/* ------------------------------------------------------------------------*/
